;	TextCommands version 1.00 Copyright (C) 2006 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

;	To compile download masm32 from http://www.masm32.com and install it on the root directory of one of your hard drives
;	Copy source files to the partition where is masm32 installed and run \masm32\bin\blddll txtCmd
;	For more information send and e-mail to cristian.albu@gmail.com

.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include	plprocs.h
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

	dlgConfig	PROTO :DWORD,:DWORD,:DWORD,:DWORD
	pThread		PROTO :DWORD


.data?
	saveflag	db	?
	hInstance	dd	?
	commands	dd	?
	bread		dd	?
	thrid		dd	?
	GetFunctions	dd	?
	RegisterCommand	dd	?
	UnregisterCommand dd	?
	RegisterHelpString dd	?
	UnregisterHelpString dd	?
	RegisterUserCommand dd	?
	UnregisterUserCommand dd ?
	NickFromId	dd	?
	IdFromNick	dd	?
	SendTo		dd	?
	SendToAll	dd	?
	cmdbuf		dd	?
	datafile	db	8192 dup(?)
	buftmp		db	65536*2 dup(?)
	buftmp1		db	65536 dup(?)
	buftmp2		db	65536 dup(?)

.code

cmdstr	struc
	nextcmd		dd	?
	cmdname		db	200 dup(?)
	selfsel		db	8192 dup(?)
	selfsel1	db	?
	usrsel		db	8192 dup(?)
	usrsel1		db	?
	multisel	db	8192 dup(?)
	multisel1	db	?
	umflags		db	?
	usermnu		db	512 dup(?)
	dispname	db	100 dup(?)
	helptxt		db	8192 dup(?)
	cmdid		dd	?
	helpid		dd	?
	ucmdid		dd	?
	helpPtr		dd	?
cmdstr	ends

newcommand	struc
	nextcmd		dd	?
	locked		db	?
	sendtoall	db	?
	cmdid		dd	?
	userid		dd	?
	targetid	dd	?
	tickcount	dd	?
	cmdparams	db	16384 dup(?)
newcommand	ends

pluginName	db	'Text commands',0
cmdpm		db	'$&#36;To: %[bot] From: %[mynick] &#36;<%[mynick]> !',0
cmdpm1		db	' %[nick]'
cmdpm2		db	'&#124;|',0
fn01		db	'RegisterCommand',0
fn02		db	'UnregisterCommand',0
fn03		db	'NickFromId',0
fn04		db	'IdFromNick',0
fn05		db	'SendTo',0
fn06		db	'SendToAll',0
fn07		db	'RegisterHelpString',0
fn08		db	'UnregisterHelpString',0
fn09		db	'RegisterUserCommand',0
fn10		db	'UnregisterUserCommand',0
pl_procs

DllEntry PROC dllInstance:DWORD,reason:DWORD,reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
		push	dllInstance
		pop	hInstance
	.elseif reason==DLL_PROCESS_DETACH
		push	esi
		push	edi
		mov	esi,commands
		.while esi
			push	dword ptr[esi]
			call	plunregister
			invoke	GlobalFree,esi
			pop	esi
		.endw
		pop	edi
		pop	esi
	.elseif reason==DLL_THREAD_ATTACH
	.else
	.endif
	xor	eax,eax
	inc	eax
	ret
DllEntry Endp

InitPlugin	PROC	GetAddr:DWORD
	mov	saveflag,0
	push	GetAddr
	pop	GetFunctions
	mov	commands,0
	mov	cmdbuf,0
	push	offset fn01
	call	GetFunctions
	mov	RegisterCommand,eax
	push	offset fn02
	call	GetFunctions
	mov	UnregisterCommand,eax
	push	offset fn07
	call	GetFunctions
	mov	RegisterHelpString,eax
	push	offset fn08
	call	GetFunctions
	mov	UnregisterHelpString,eax
	push	offset fn09
	call	GetFunctions
	mov	RegisterUserCommand,eax
	push	offset fn10
	call	GetFunctions
	mov	UnregisterUserCommand,eax
	push	offset fn03
	call	GetFunctions
	mov	NickFromId,eax
	push	offset fn04
	call	GetFunctions
	mov	IdFromNick,eax
	push	offset fn05
	call	GetFunctions
	mov	SendTo,eax
	push	offset fn06
	call	GetFunctions
	mov	SendToAll,eax
	call	getdatafile
	call	loadsettings
	invoke	CreateThread,0,0,addr pThread,0,0,addr thrid
	mov	thrid,eax
	lea	eax,pluginName
	ret
InitPlugin	ENDP

UnloadPlugin	PROC
	invoke	TerminateThread,thrid,0
	push	esi
	push	edi
	mov	esi,commands
	.while esi
		push	dword ptr[esi]
		push	esi
		call	plunregister
		pop	esi
		invoke	GlobalFree,esi
		pop	esi
	.endw
	mov	esi,cmdbuf
	.while esi
		push	dword ptr[esi]
		invoke	GlobalFree,esi
		pop	esi
	.endw
	mov	commands,0
	mov	cmdbuf,0
	pop	edi
	pop	esi
	ret
UnloadPlugin	ENDP

GetConfig	PROC	hParent:DWORD
	invoke	DialogBoxParam,hInstance,1000,hParent,offset dlgConfig,0
	ret
GetConfig	ENDP

assume	esi:ptr cmdstr
dlgConfig	PROC	uses esi edi ebx hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.if uMsg==WM_INITDIALOG
		invoke	SendDlgItemMessage,hDlg,100,EM_LIMITTEXT,200,0
		invoke	SendDlgItemMessage,hDlg,200,LB_RESETCONTENT,0,0
		.if commands==0
			invoke	CheckDlgButton,hDlg,501,BST_CHECKED
			invoke	CheckDlgButton,hDlg,511,BST_CHECKED
			invoke	CheckDlgButton,hDlg,521,BST_CHECKED
		.else
			mov	esi,commands
			.while esi!=0
				lea	edi,buftmp
				lea	edx,[esi].cmdname
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=32)
					mov	al,[edx]
					stosb
					inc	edx
				.endw
				mov	al,0
				stosb
				invoke	SendDlgItemMessage,hDlg,200,LB_ADDSTRING,0,addr buftmp
				invoke	SendDlgItemMessage,hDlg,200,LB_SETITEMDATA,eax,esi
				mov	esi,dword ptr[esi]
			.endw
			invoke	SendDlgItemMessage,hDlg,200,LB_SETCURSEL,0,0
			jmp	_lbsel
		.endif
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		mov	ebx,eax
		shr	ebx,16
		.if ax==2
			invoke	EndDialog,hDlg,1
		.elseif ax==3
			mov	saveflag,1
			invoke GetDlgItemText,hDlg,100,addr buftmp,200
			mov	esi,offset buftmp
			mov	edi,esi
			.while byte ptr[esi]!=0
				.if byte ptr[esi]==32
					.while byte ptr[esi]==32
						inc	esi
					.endw
					dec	esi
				.endif
				movsb
			.endw
			movsb
			mov	edx,offset commands
			mov	esi,[edx]
			.while esi!=0
				lea	edx,[esi].cmdname
				xor	ecx,ecx
				.while byte ptr[edx+ecx]!=0
					mov	al,[edx+ecx]
					mov	ah,buftmp[ecx]
					.if (al<='Z')&&(al>='A')
						or	al,20h
					.endif
					.if (ah<='Z')&&(ah>='A')
						or	ah,20h
					.endif
					.break .if al!=ah
					inc	ecx
				.endw
				.if (al==ah)&&(byte ptr[edx+ecx]==0)&&(buftmp[ecx]==0)
					call	plunregister
					jmp	updcmd
				.endif
				mov	edx,esi
				mov	esi,dword ptr[esi]
			.endw
			mov	esi,edx
			invoke	GlobalAlloc,GPTR,sizeof cmdstr
			mov	dword ptr[esi],eax
			mov	esi,eax
			mov	dword ptr[esi],0
			lea	edx,buftmp
			lea	edi,[esi].cmdname
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=32)
				mov	al,[edx]
				stosb
				inc	edx
			.endw
			mov	al,0
			stosb
			invoke	SendDlgItemMessage,hDlg,200,LB_ADDSTRING,0,addr [esi].cmdname
			mov	dword ptr[esi+200-4].cmdname,0
			invoke	SendDlgItemMessage,hDlg,200,LB_SETITEMDATA,eax,esi
updcmd:			lea	edx,buftmp
			lea	edi,[esi].cmdname
			call	copyedx
			mov	al,0
			stosb
			invoke	GetDlgItemText,hDlg,101,addr [esi].selfsel,8191
			invoke	GetDlgItemText,hDlg,102,addr [esi].usrsel,8191
			invoke	GetDlgItemText,hDlg,103,addr [esi].multisel,8191
			invoke	GetDlgItemText,hDlg,104,addr [esi].helptxt,8191
			invoke	GetDlgItemText,hDlg,105,addr [esi].dispname,99
			invoke	IsDlgButtonChecked,hDlg,500
			.if eax==BST_CHECKED
				mov	[esi].selfsel1,0
			.else
				invoke	IsDlgButtonChecked,hDlg,501
				.if eax==BST_CHECKED
					mov	[esi].selfsel1,1
				.else
					mov	[esi].selfsel1,2
				.endif
			.endif
			invoke	IsDlgButtonChecked,hDlg,510
			.if eax==BST_CHECKED
				mov	[esi].usrsel1,0
			.else
				invoke	IsDlgButtonChecked,hDlg,511
				.if eax==BST_CHECKED
					mov	[esi].usrsel1,1
				.else
					mov	[esi].usrsel1,2
				.endif
			.endif
			invoke	IsDlgButtonChecked,hDlg,520
			.if eax==BST_CHECKED
				mov	[esi].multisel1,0
			.else
				invoke	IsDlgButtonChecked,hDlg,521
				.if eax==BST_CHECKED
					mov	[esi].multisel1,1
				.else
					mov	[esi].multisel1,2
				.endif
			.endif
			mov	[esi].umflags,0
			lea	edi,[esi].usermnu
			mov	eax,'esU$'
			stosd
			mov	eax,'moCr'
			stosd
			mov	eax,'dnam'
			stosd
			mov	eax,'0 2 '
			stosd
			invoke	IsDlgButtonChecked,hDlg,400
			.if eax==BST_CHECKED
				or	[esi].umflags,1
				or	byte ptr[edi-1],6
			.endif
			invoke	IsDlgButtonChecked,hDlg,401
			.if eax==BST_CHECKED
				or	[esi].umflags,2
				or	byte ptr[edi-1],1
			.endif
			invoke	IsDlgButtonChecked,hDlg,5
			.if eax==BST_CHECKED
				or	[esi].umflags,4
			.endif
			mov	al,32
			stosb
			lea	edx,[esi].dispname
			.if byte ptr[edx]!=0
				call	copyedx
			.else
				xor	ecx,ecx
				.while (ecx<100)&&(byte ptr[esi+ecx].cmdname!=0)&&(byte ptr[esi+ecx].cmdname!=32)
					mov	al,[esi+ecx].cmdname
					.if ecx==0
						.if (al>='a')&&(al<='z')
							sub	al,32
						.endif
					.else
						.if (al>='A')&&(al<='Z')
							or	al,32
						.endif
					.endif
					stosb
					inc	ecx
				.endw
			.endif
			lea	edx,cmdpm
			call	copyedx
			xor	ecx,ecx
			.while (ecx<100)&&(byte ptr[esi+ecx].cmdname!=0)
				mov	al,[esi+ecx].cmdname
				stosb
				inc	ecx
			.endw
			lea	edx,cmdpm2
			.if [esi].umflags&1
				lea	edx,cmdpm1
			.endif
			call	copyedx
			mov	al,0
			stosb
			xor	ecx,ecx
			.while 1
				push	ecx
				invoke	SendDlgItemMessage,hDlg,200,LB_GETITEMDATA,ecx,0
				pop	ecx
				.if eax==esi
					invoke	SendDlgItemMessage,hDlg,200,LB_SETCURSEL,ecx,0
					.break
				.endif
				inc	ecx
			.endw
			call	plregister
		.elseif ax==4
			mov	saveflag,1
			invoke	SendDlgItemMessage,hDlg,200,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				push	eax
				invoke	SendDlgItemMessage,hDlg,200,LB_GETITEMDATA,eax,0
				mov	esi,eax
				lea	edx,commands
				.while dword ptr[edx]!=0
					.if esi==[edx]
						mov	eax,dword ptr[esi]
						mov	[edx],eax
						call	plunregister
						invoke	GlobalFree,esi
						.break
					.endif
					mov	edx,[edx]
				.endw
				pop	eax
				invoke	SendDlgItemMessage,hDlg,200,LB_DELETESTRING,eax,0
			.endif
		.elseif (ax==200)&&(bx==LBN_SELCHANGE)
_lbsel:			invoke	SendDlgItemMessage,hDlg,200,LB_GETCURSEL,0,0
			.if eax!=LB_ERR
				invoke	SendDlgItemMessage,hDlg,200,LB_GETITEMDATA,eax,0
				.if eax!=LB_ERR
					mov	esi,eax
					invoke	SetDlgItemText,hDlg,100,addr [esi].cmdname
					invoke	SetDlgItemText,hDlg,101,addr [esi].selfsel
					invoke	SetDlgItemText,hDlg,102,addr [esi].usrsel
					invoke	SetDlgItemText,hDlg,103,addr [esi].multisel
					invoke	SetDlgItemText,hDlg,104,addr [esi].helptxt
					invoke	SetDlgItemText,hDlg,105,addr [esi].dispname
					invoke	CheckDlgButton,hDlg,500,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,501,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,502,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,510,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,511,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,512,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,520,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,521,BST_UNCHECKED
					invoke	CheckDlgButton,hDlg,522,BST_UNCHECKED
					.if [esi].selfsel1==0
						invoke	CheckDlgButton,hDlg,500,BST_CHECKED
					.elseif [esi].selfsel1==1
						invoke	CheckDlgButton,hDlg,501,BST_CHECKED
					.else
						invoke	CheckDlgButton,hDlg,502,BST_CHECKED
					.endif
					.if [esi].usrsel1==0
						invoke	CheckDlgButton,hDlg,510,BST_CHECKED
					.elseif [esi].usrsel1==1
						invoke	CheckDlgButton,hDlg,511,BST_CHECKED
					.else
						invoke	CheckDlgButton,hDlg,512,BST_CHECKED
					.endif
					.if [esi].multisel1==0
						invoke	CheckDlgButton,hDlg,520,BST_CHECKED
					.elseif [esi].multisel1==1
						invoke	CheckDlgButton,hDlg,521,BST_CHECKED
					.else
						invoke	CheckDlgButton,hDlg,522,BST_CHECKED
					.endif
					mov	eax,BST_UNCHECKED
					.if [esi].umflags&1
						mov	eax,BST_CHECKED
					.endif
					invoke	CheckDlgButton,hDlg,400,eax
					mov	eax,BST_UNCHECKED
					.if [esi].umflags&2
						mov	eax,BST_CHECKED
					.endif
					invoke	CheckDlgButton,hDlg,401,eax
					mov	eax,BST_UNCHECKED
					.if [esi].umflags&4
						mov	eax,BST_CHECKED
					.endif
					invoke	CheckDlgButton,hDlg,5,eax
				.endif
			.endif
		.endif
	.endif
	xor	eax,eax
	ret
dlgConfig	ENDP

_about	db	'Albu Cristian, 2006',0
GetAboutText	PROC
	mov	eax,offset _about
	ret
GetAboutText	ENDP

SaveSettings	PROC
	.if saveflag==0
		ret
	.endif
	invoke	SetFileAttributes,addr datafile,0
	invoke	DeleteFile,addr datafile
	.if commands
		invoke	CreateFile,addr datafile,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
		.if eax!=INVALID_HANDLE_VALUE
			push	eax
			mov	edi,eax
			mov	esi,commands
			.while esi
				push	edi
				lea	edi,buftmp+2
				mov	al,[esi].selfsel1
				stosb
				mov	al,[esi].usrsel1
				stosb
				mov	al,[esi].multisel1
				stosb
				mov	al,[esi].umflags
				stosb
				lea	edx,[esi].cmdname
				call	copystr
				lea	edx,[esi].selfsel
				call	copystr
				lea	edx,[esi].usrsel
				call	copystr
				lea	edx,[esi].multisel
				call	copystr
				lea	edx,[esi].usermnu
				call	copystr
				lea	edx,[esi].dispname
				call	copystr
				lea	edx,[esi].helptxt
				call	copystr
				mov	ecx,edi
				pop	edi
				sub	ecx,offset buftmp
				movzx	ecx,cx
				mov	word ptr buftmp,cx
				invoke	WriteFile,edi,addr buftmp,ecx,addr bread,0
				mov	esi,dword ptr[esi]
			.endw
			call	CloseHandle
		.endif
	.endif
	ret
SaveSettings	ENDP

loadsettings:
	invoke	CreateFile,addr datafile,GENERIC_READ,0,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		lea	esi,commands
		.while 1
			mov	word ptr buftmp,0
			invoke	ReadFile,edi,addr buftmp,2,addr bread,0
			.break .if (bread!=2)||(word ptr buftmp<2)
			dec	word ptr buftmp
			dec	word ptr buftmp
			movzx	ecx,word ptr buftmp
			invoke	ReadFile,edi,addr buftmp+2,ecx,addr bread,0
			movzx	ecx,word ptr buftmp
			.break .if ecx!=bread
			invoke	GlobalAlloc,GPTR,sizeof cmdstr
			push	edi
			push	eax
			push	ecx
			mov	ecx,sizeof cmdstr
			mov	edi,eax
			xor	eax,eax
			rep	stosb
			pop	ecx
			pop	eax
			pop	edi
			mov	dword ptr[esi],eax
			mov	esi,eax
			mov	dword ptr[esi],0
			push	edi
			mov	al,byte ptr buftmp+2
			mov	[esi].selfsel1,al
			mov	al,byte ptr buftmp+3
			mov	[esi].usrsel1,al
			mov	al,byte ptr buftmp+4
			mov	[esi].multisel1,al
			mov	al,byte ptr buftmp+5
			mov	[esi].umflags,al
			lea	edi,[esi].cmdname
			lea	edx,buftmp+6
			call	copystr1
			lea	edi,[esi].selfsel
			call	copystr1
			lea	edi,[esi].usrsel
			call	copystr1
			lea	edi,[esi].multisel
			call	copystr1
			lea	edi,[esi].usermnu
			call	copystr1
			lea	edi,[esi].dispname
			call	copystr1
			lea	edi,[esi].helptxt
			call	copystr1
			call	plregister
			pop	edi
		.endw
		call	CloseHandle
	.endif
	ret

plregister:
	.if ([esi].umflags&4)
		ret
	.endif
	mov	[esi].cmdid,0
	.if [esi].cmdname
		push	offset procfn
		lea	eax,[esi].cmdname
		push	eax
		call	RegisterCommand
		mov	[esi].cmdid,eax
	.endif
	mov	[esi].helpid,0
	mov	[esi].helpPtr,0
	push	edi
	.if byte ptr[esi].helptxt!=0
		invoke	GlobalAlloc,GPTR,16384
		mov	[esi].helpPtr,eax
		mov	edi,eax
		mov	al,'!'
		stosb
		lea	edx,[esi].cmdname
		call	copyedx
		mov	eax,92d0909h
		stosd
		lea	edx,[esi].helptxt
		call	copyedx
		mov	byte ptr[edi],0
		push	6
		push	[esi].helpPtr
		push	edi
		call	RegisterHelpString
		mov	[esi].helpid,eax
	.endif
	pop	edi
	mov	[esi].ucmdid,0
	.if [esi].usermnu
		lea	eax,[esi].usermnu
		push	eax
		call	RegisterUserCommand
		mov	[esi].ucmdid,eax
	.endif
	ret

plunregister:
	.if ([esi].umflags&4)
		ret
	.endif
	.if [esi].cmdid
		push	[esi].cmdid
		call	UnregisterCommand
		mov	[esi].cmdid,0
	.endif
	.if [esi].helpid
		push	[esi].helpid
		call	UnregisterHelpString
		mov	[esi].helpid,0
	.endif
	.if [esi].helpPtr
		invoke	GlobalFree,[esi].helpPtr
	.endif
	.if [esi].ucmdid
		push	[esi].ucmdid
		call	UnregisterUserCommand
		mov	[esi].ucmdid,0
	.endif
	.if dword ptr[esi+200-4].cmdname
		invoke	GlobalFree,dword ptr[esi+200-4].cmdname
		mov	dword ptr[esi+200-4].cmdname,0
	.endif
	ret

;ebx=params
;edx=string to send
;edi=dest
getmsg:
	push	eax
	.while (byte ptr[edx]!=0)
		.if word ptr[edx]=='[%'
			push	esi
			push	edx
			push	ebx
			lea	esi,[edx+2]
			call	atoi
			pop	ebx
			pop	edx
			dec	esi
			pop	esi
			.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=']')
				inc	edx
			.endw
			.if byte ptr[edx]==']'
				inc	edx
			.endif
			.if eax
				dec	eax
				xor	ecx,ecx
				.while eax
					.while (byte ptr[ebx+ecx]!='|')&&(byte ptr[ebx]!=0)
						.break .if (byte ptr[ebx+ecx]==32)||(byte ptr[ebx+ecx]==9)||(byte ptr[ebx+ecx]==13)||(byte ptr[ebx+ecx]==10)
						inc	ecx
					.endw
					dec	eax
					.while (byte ptr[ebx+ecx]==32)||(byte ptr[ebx+ecx]==9)||(byte ptr[ebx+ecx]==13)||(byte ptr[ebx+ecx]==10)
						inc	ecx
					.endw
				.endw
				.while (byte ptr[ebx+ecx]==32)||(byte ptr[ebx+ecx]==9)||(byte ptr[ebx+ecx]==13)||(byte ptr[ebx+ecx]==10)
					inc	ecx
				.endw
				push	ebx
				push	ecx
				push	edx
				lea	ebx,[ebx+ecx]
				push	ebx
				call	IdFromNick
				pop	edx
				.if eax!=-1
					push	edx
					push	edi
					push	eax
					call	NickFromId
					pop	edx
					pop	ecx
					pop	ebx
					.while byte ptr[edi]!=0
						inc	edi
					.endw
				.else
					pop	ecx
					pop	ebx
					.while (byte ptr[ebx+ecx]!=0)&&(byte ptr[ebx+ecx]!=10)&&(byte ptr[ebx+ecx]!=13)&&(byte ptr[ebx+ecx]!='|')&&(byte ptr[ebx+ecx]!=9)&&(byte ptr[ebx+ecx]!=32)
						mov	al,[ebx+ecx]
						stosb
						inc	ecx
					.endw
				.endif
			.else
				pop	eax
				push	eax
				push	edx
				push	ebx
				push	edi
				push	eax
				call	NickFromId
				pop	ebx
				pop	edx
				.while byte ptr[edi]!=0
					inc	edi
				.endw
			.endif
			dec	edx
		.else
			mov	al,[edx]
			stosb
		.endif
		inc	edx
	.endw
	mov	ax,'|'
	stosw
	pop	eax
	ret

username	struc
	db	40 dup(?)
username	ends

procfn	PROC	uses esi edi ebx cmdID:DWORD,userId:DWORD,lpRights:DWORD,lpParams:DWORD,isPM:DWORD
	local	targetnick:username
	mov	esi,commands
	mov	eax,cmdID
	.while esi
		.break .if eax==[esi].cmdid
		mov	esi,dword ptr[esi]
	.endw
	.if (esi==0)||(eax!=[esi].cmdid)
		ret
	.endif
	mov	edx,cmdbuf
	mov	eax,cmdID
	mov	ecx,userId
	.while edx
		assume	edx:ptr newcommand
		.if (eax==[edx].cmdid)&&(ecx==[edx].userid)&&([edx].locked==0)
			inc	[edx].locked
			.if [edx].locked==1
				push	edx
				mov	eax,lpParams
				push	eax
				call	IdFromNick
				pop	edx
				push	edx
				mov	[edx].targetid,eax
				push	edx
				invoke	GetTickCount
				pop	edx
				mov	[edx].tickcount,eax
				mov	al,[esi].multisel1
				.if al==2
					mov	[edx].sendtoall,1
				.else
					mov	[edx].sendtoall,0
				.endif
				lea	edi,[edx].cmdparams
				formatmsg
				lea	edx,[esi].multisel
				mov	ebx,lpParams
				mov	eax,userId
				call	getmsg
				pop	edx
				dec	[edx].locked
				ret
			.endif
		.endif
		assume	edx:nothing
		mov	edx,[edx]
	.endw

	invoke	GlobalAlloc,GPTR,sizeof newcommand
	assume	edi:ptr newcommand
	mov	edi,eax
	push	edi
	mov	eax,lpParams
	push	eax
	call	IdFromNick
	mov	[edi].targetid,eax
	.if (eax==userId)
		mov	al,[esi].selfsel1
		.if al==2
			mov	[edi].sendtoall,1
		.else
			mov	[edi].sendtoall,0
		.endif
		lea	edi,[edi].cmdparams
		formatmsg
		lea	edx,[esi].selfsel
		mov	ebx,lpParams
		mov	eax,userId
		call	getmsg
	.else
		mov	al,[esi].usrsel1
		.if al==2
			mov	[edi].sendtoall,1
		.else
			mov	[edi].sendtoall,0
		.endif
		lea	edi,[edi].cmdparams
		formatmsg
		lea	edx,[esi].usrsel
		mov	ebx,lpParams
		mov	eax,userId
		call	getmsg
	.endif
	pop	edi
	mov	[edi].nextcmd,0
	mov	[edi].locked,0
	mov	eax,cmdID
	mov	[edi].cmdid,eax
	mov	eax,userId
	mov	[edi].userid,eax
	invoke	GetTickCount
	mov	[edi].tickcount,eax
	mov	edx,offset cmdbuf
	.while dword ptr[edx]!=0
		mov	edx,[edx]
	.endw
	mov	[edx],edi
	assume	edi:nothing
	ret
procfn	ENDP

pThread	PROC	lParam:DWORD
	.while 1
		invoke	Sleep,100
		invoke	GetTickCount
		mov	edx,cmdbuf
		.while edx
			assume	edx:ptr newcommand
			mov	ecx,eax
			sub	ecx,[edx].tickcount
			.if ecx>7fffffffh
				neg	ecx
			.endif
			.if ecx>200
				push	edx
				mov	[edx].locked,1
				lea	ebx,[edx].cmdparams
				xor	ecx,ecx
				.while byte ptr[ebx+ecx]!=0
					inc	ecx
				.endw
				.if [edx].sendtoall
					push	ecx
					push	ebx
					call	SendToAll
				.else
					push	ecx
					push	ebx
					push	[edx].userid
					call	SendTo
				.endif
				pop	edx
				mov	ecx,offset cmdbuf
				.while dword ptr[ecx]!=0
					.if edx==[ecx]
						mov	eax,dword ptr[edx]
						mov	[ecx],eax
						push	ecx
						invoke	GlobalFree,edx
						pop	edx
						.break
					.endif
					mov	ecx,[ecx]
				.endw
			.endif
			assume	edx:nothing
			mov	edx,[edx]
		.endw
	.endw
	invoke	ExitThread,0
	ret
pThread	ENDP

assume	edx:ptr cmdstr
include	wtbl.h
HTTPEnumerateData	PROC	uses esi edi ebx userId:DWORD,lpszPath:DWORD,lpszHost:DWORD,lpszReferer:DWORD,lpszUserAgent:DWORD,lpszCookies:DWORD,enumerationIndex:DWORD,lpParameters:DWORD,lpBuffer:DWORD,dataOffset:DWORD
	local	_line:DWORD
	mov	edi,lpBuffer
	mov	esi,lpParameters
	.if byte ptr[esi]=='+'
		mov	_line,1
		inc	esi
	.else
		.if enumerationIndex
			xor	eax,eax
			dec	eax
			ret
		.endif
		mov	_line,0
	.endif
	mov	edx,commands
	.while edx
		.if (!([edx].umflags&4))
			lea	ebx,[edx].cmdname
			xor	ecx,ecx
			.while byte ptr[ebx+ecx]
				mov	al,[ebx+ecx]
				mov	ah,[esi+ecx]
				or	ax,2020h
				.break .if al!=ah
				inc	ecx
			.endw
			.if (byte ptr[ebx+ecx]==0)&&((byte ptr[esi+ecx]<=32)||(byte ptr[esi+ecx]==']'))
				.if dword ptr[edx].cmdname[200-4]==0
					push	edx
					invoke	GlobalAlloc,GPTR,32768
					pop	edx
					push	edx
					mov	dword ptr[edx+200-4].cmdname,eax
					.if [edx].selfsel
						lea	edx,[edx].selfsel
					.elseif [edx].usrsel
						lea	edx,[edx].usrsel
					.elseif [edx].multisel
						lea	edx,[edx].multisel
					.endif
					push	edi
					mov	edi,eax
					mov	ebx,edx
					.while byte ptr[ebx]
						mov	al,[ebx]
						.if al==9
							push	edx
							lea	edx,_tab
							call	copyedx
							pop	edx
						.else
							.if (al==13)&&(byte ptr[ebx+1]==10)
								inc	ebx
							.endif
							call	_esc1
						.endif
						inc	ebx
					.endw
					mov	al,0
					stosb
					pop	edi
					pop	edx
				.endif
				mov	edx,dword ptr[edx+200-4].cmdname
				.if _line
					.while (enumerationIndex!=0)&&(byte ptr[edx]!=0)
						.if (dword ptr[edx]=='>RB<')
							lea	edx,[edx+4]
							dec	enumerationIndex
						.elseif byte ptr[edx]==0
							.break
						.else
							inc	edx
						.endif
					.endw
					.if enumerationIndex
						xor	eax,eax
						dec	eax
						ret
					.endif
					.while dataOffset
						.break .if (byte ptr[edx]==0)||(dword ptr[edx]=='>RB<')
						dec	dataOffset
						inc	edx
					.endw
					.if (byte ptr[edx]==0)
						xor	eax,eax
						dec	eax
						ret
					.elseif (dword ptr[edx]=='>RB<')
						xor	eax,eax
						ret
					.endif
					xor	ecx,ecx
					.while ecx<4096
						mov	al,[edx+ecx]
						.break .if (al==0)||(dword ptr[edx+ecx]=='>RB<')
						stosb
						inc	ecx
					.endw
				.else
					.while dataOffset
						.break .if byte ptr[edx]==0
						dec	dataOffset
						inc	edx
					.endw
					.if byte ptr[edx]==0
						xor	eax,eax
						dec	eax
						ret
					.endif
					xor	ecx,ecx
					.while ecx<4096
						mov	al,[edx+ecx]
						.break .if al==0
						stosb
						inc	ecx
					.endw
				.endif
				mov	eax,ecx
				ret
			.endif
		.endif
		assume	edx:nothing
		mov	edx,[edx]
	.endw
	xor	eax,eax
	dec	eax
	ret
HTTPEnumerateData	ENDP
assume	edx:nothing

assume	esi:nothing
End DllEntry
